// *********************************************************************
//
//  created:    2015/09/18
//  filename:   FizzBuzz.h
//
//  author:     Gerald Dherbomez
//              Copyright Heudiasyc (c) UMR UTC/CNRS 7253
// 
//  license:    CECILL-C
// 
//  version:    $Id: $
//
//  brief:      Pacpus template component header file
//
// *********************************************************************


#ifndef __FizzBuzz_h__
#define __FizzBuzz_h__

#include <Pacpus/kernel/PacpusLibConfig.h>
#include <Pacpus/kernel/ComponentBase.h>
#include <Pacpus/kernel/InputOutputInterface.h>
#include <Pacpus/kernel/DbiteFile.h>

namespace pacpus 
{

  class PACPUSLIB_API FizzBuzz
  : public QObject
  , public ComponentBase
  {
    Q_OBJECT

  public:
    // Specific constructor for pacpus component
    FizzBuzz(QString name); 
    ~FizzBuzz();

    // 3 inherited virtual pure methods
    virtual void startActivity();
    virtual void stopActivity();
    virtual ComponentBase::COMPONENT_CONFIGURATION configureComponent(XmlComponentConfig config); 

    virtual void addInputs();
    virtual void addOutputs();

    // void produceOutput();
    // void processInput(const int& value);


  private:
    // Add here your private variables
    int counter_; 

    // Declaration of an output
    // OutputInterface<int, FizzBuzz>* out1_;
    

  }; // end class FizzBuzz

} // end namespace pacpus

#endif 